/*
    This class has just one static method. The method takes a string as a
    parameter. This parameter is the name of the machine (could be ip number
    also). It returns a string which is an encoding of the ip number of the
    machine represented by the parameter. The idea behind the encoding is 
    as follows :
    	get the ip number of the machine. Take the four fields of this number
    and construct a string of length 4 from it, where each character stands for
    one field of the ip number. In case, no such machine exits, we assign it an
    ip number of "0.0.0.0", a good enough assumption.
    
*/
import java.sql.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class IPAddress {

    public static String ipAddress (String machine_name) {
        try {
            InetAddress Addr = InetAddress.getByName (machine_name);
	    byte ip_in_bytes[] = Addr.getAddress();
	    return new String (ip_in_bytes); 
	}
	catch (Exception e) {
	    char chars[] = {'\0', '\0', '\0', '\0' };
	    return new String (chars);
	}
    }
}
