/* This class represents a session for a user of the package.
   The main function is to translate queries from the input fields of the 
   of the HTML forms to SQL queries. The query is then fed through a connection    to the SQL machine and the result of the query is displayed
   */



import java.util.*;
import java.sql.*;
import javax.servlet.http.*;
import java.io.*;
import javax.servlet.*;

// whenever any error is detected in format of some field, i am throwing an 
// exception of my own

public class Session
{
    public String loginid;  // stores the loginid of the user
    MyChar perms = new MyChar ('X');  // stores the permissions of the user

    public void processForm (PrintWriter out, HttpServletRequest req,
    	Connection con) 
    {
        try {
	    Statement stmt = con.createStatement ();
	    ResultSet rs;

	    String form_name[] = req.getParameterValues("form_name");
	
	    if (form_name[0].equals("notgeneral") ||
	    	    form_name[0].equals("general") ||
		    form_name[0].equals("root"))
	    {
	        String pressed[] = req.getParameterValues("choice");
		printHeader(out,"header.html");
	        printPage(out,pressed[0]);
	    }
          //----------------------------------------------------------------
	  //process form 1- most popular urls
          //---------------------------------------------------------------
	    else { 
		printHeader(out,"header.html");
	        String top[] = req.getParameterValues("top");
	        String tofq[] = req.getParameterValues("tofq"); 
	        if (form_name[0].equals("url")) {
 		    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
		    String st[] = req.getParameterValues("st");
		    String keywords[] = req.getParameterValues("keywords");
		    String domain = "";
		    if (tofq[0].equals("url")) 
		      	domain = st[0];
		    int topno = Integer.parseInt(top[0]);
		    String result, temp;
		    int count;
		    String query = 
"SELECT * FROM (SELECT url_requested, count (*) AS cnt FROM "+
"proxy_log WHERE url_requested LIKE '%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND url_requested LIKE '%" +domain+"%' AND log_tag NOT " +
"LIKE '%ERR%' AND log_tag NOT LIKE '%DENIED%'  GROUP BY "+ "url_requested)"+
" ORDER BY cnt DESC";
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
    	      	        if (rs.next()) {
    			    result = rs.getString("url_requested");
			    count = rs.getInt("cnt");
    			    if (tofq[0].equals("url")) {
			      	if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100%>");
				    out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			        }

			       out.println("<tr><td>"+result + " <td> " +count+"</tr>");
    			    }
    		            else {
			        if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100% >");
				    out.println("<tr><td><center>Domain</center><td>No. of Hits</tr>");
			        }
    		  	        int index = result.indexOf("/");
    		   	        if (index == -1) {
			    	    count = rs.getInt("cnt");
    		    		    out.println("<tr><td>"+result+" <td> "+count+"</tr>");
    		    	        }
    		  	        else {
    		    		    int index1 = result.indexOf(keywords[0]);
    		    		    if ((index1 != -1) &&  (index1 <= index))
			    	        count = rs.getInt("cnt");
    		      		        out.println("<tr><td>"+result.substring(0,index)+" <td> "+count+"</tr>");
    		  	        }
    			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
    	      	        }
    	      	        else {
    	         	    if (i == 0) {
    		     	        out.println("no such url/domain exists");
    		 	    } else {
			    	out.println("</table></center></body></html>");
			    }
    		 	    break;
    	      	        }
	    	    }
	    	    out.close();
		}
	  //----------------------------------------------------------	  
	  // process form #2 - image download sites
	  //---------------------------------------------------------
	    	else if (form_name[0].equals("images")) {
 	    	    long from = processDate (req,"1");
	            try {
	      	    	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String type1, type2;
	    
		    if (tofq[0].equals("images")) { 
		    	type1 = "I"; type2="I";
	      	    }
		    else if (tofq[0].equals("text")) {
		    	type1="T"; type2="T";
	      	    }
	    	    else { 	// both
	      	     	type1="I" ;type2="T";
	      	    }
	      	      
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
	    
	    	    String query = "select * FROM (select" +
" url_requested,COUNT(*) AS cnt FROM proxy_log WHERE ( content_type LIKE '%" + 
 type1 + "%' OR content_type LIKE '%" + type2 + "%' ) AND url_requested LIKE "+
"'%"+ keywords[0] + "%'  AND time BETWEEN "+
from+" AND "+to+" AND log_tag NOT " + "LIKE '%ERR%' AND log_tag NOT LIKE "+
" '%DENIED%' GROUP BY "+ "url_requested) ORDER BY cnt DESC" ;
	      
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    if (i == 0) {
				out.println("<center><table border=1 cellpadding = 5 width=100%>");
				out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			    }
			    result = rs.getString("url_requested");
			    count = rs.getInt("cnt");
			    out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      		}
	      	   	else {
	         	    if (i == 0) {
		     		out.println("no such url/domain exists");
		 	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
	  //------------------------------------------------
	  // process form 3- personal favorite sites
	  //------------------------------------------------
	  
	  	else if (form_name[0].equals("personal")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String st[] = req.getParameterValues("st");
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String domain = "";
	    // we neglect the choice of domain if he wants to search for domains
	    	    if (tofq[0].equals("url")) 
	      		domain = st[0];
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
String query = "SELECT * FROM (SELECT url_requested, COUNT (*) AS cnt FROM "+
"proxy_log WHERE url_requested LIKE '%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+ to+" AND url_requested LIKE '%" +domain+"%' AND log_tag NOT " +
"LIKE '%ERR%' AND user_name = '" +loginid+ "' GROUP BY "+ "url_requested)"+ 
" ORDER BY cnt DESC";
 
            	    out.println(loginid+"<BR>");
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      	    	if (rs.next()) {
			    result = rs.getString("url_requested");
			    count = rs.getInt("cnt");
			    if (tofq[0].equals("url")) {
			    	if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100%>");
				    out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			    	}
			        out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    }
			    else {
		  	    	int index = result.indexOf("/");
		  	    	if (index == -1) {
			            out.println("<tr><td>"+result + " <td> " +count+"</tr>");
		  	    	}
		  	    	else {
		    		    int index1 = result.indexOf(keywords[0]);
		    		    if ((index1 != -1) &&  (index1 <= index))
			                out.println("<tr><td>"+result.substring(0,index) + " <td> " +count+"</tr>");
		  	    	}
			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      	    	}
	      	    	else {
	         	    if (i == 0) {
		     	    	out.println("no such url/domain exists");
		 	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	            	}
	    	    }
	    	    out.close();
	  	}
	    //--------------------------------------------------
	    // process form number four - personal favorite download domain
	    //--------------------------------------------------
	  	else if (form_name[0].equals("pimages")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String type1, type2;
	    
		    if (tofq[0].equals("images")) { 
		    	type1 = "I"; type2="I";
	      	    }
		    else if (tofq[0].equals("text")) {
		    	type1="T"; type2="T";
	      	    }
	    	    else { 	// both
	      	     	type1="I" ;type2="T";
	      	    }
		    
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
	    
	    String query = "select * FROM (select" +
" url_requested,COUNT(*) AS cnt FROM proxy_log WHERE ( content_type LIKE '%" + 
 type1 + "%' OR content_type LIKE '%" + type2 + "%' ) AND url_requested LIKE "+
"'%"+ keywords[0] + "%' AND log_tag NOT " +
"LIKE '%ERR%' AND time BETWEEN "+
from+" AND "+to+" AND user_name = '" + loginid + "' GROUP BY "+
"url_requested) ORDER BY cnt DESC" ;

	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    if (i == 0) {
				out.println("<center><table border=1 cellpadding = 5 width=100%>");
				out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			    }
			    result = rs.getString("url_requested");
			    out.println(result+"<BR>");
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      		}
	      	 	else {
	        	    if (i == 0) {
		     		out.println("no such url/domain exists");
			    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      	    	}
	    	    }
	    	    out.close();
	  	}
	  
	    //------------------------------------------------	 
 	    // process form #5 - most active users
	    //------------------------------------------------
	  	else if (form_name[0].equals("user")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");
	      	      
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp,query;
		    int count, amount;
	    
            	    if (tofq[0].equals("download")) 
	    	    {
		
	     query = "select * FROM (select" +
" user_name,SUM(doc_size) AS sum1 FROM proxy_log WHERE url_requested LIKE"+ 
"'%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND log_tag NOT LIKE '%ERR%' AND user_name != 'guest' "+
" AND user_name != 'anonymous' GROUP BY user_name) ORDER BY sum1 DESC" ;
	    	    }
	    	    else 
	    	    {
	     query = "select * FROM (select" +
" user_name,COUNT(*) AS cnt FROM proxy_log WHERE url_requested LIKE"+ 
"'%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND log_tag NOT LIKE '%ERR%'" + 
	       "GROUP BY user_name) ORDER BY cnt DESC" ;
	    	    }
	    	      
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("user_name");
            	    	    if (tofq[0].equals("download")) {
			    	if (i == 0) {
				     out.println("<center><table border=1 cellpadding = 5 width=100%>");
				     out.println("<tr><td><center>User</center><td>No. of Bytes</tr>");
			    	}
			    	amount = rs.getInt ("sum1");
			        out.println("<tr><td>"+result + " <td> " +amount+"</tr>");
			    } 
			    else {
			    	if (i == 0) {
				     out.println("<center><table border=1 cellpadding = 5 width=100%>");
				     out.println("<tr><td><center>User</center><td>No. of Requests</tr>");
			    	}
			    	count = rs.getInt ("cnt");
			        out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      	    	}
	      		else {
	        	    if (i == 0) {
		     		out.println("no such user exists");
			    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
		
	  //-----------------------------------------------
	  // process form 6 - most active machines
	  //-----------------------------------------------
	  	else if (form_name[0].equals("machine")) {
    // here, "tofq" denotes the options : by download size / number of requests 
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");
	    
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp,query;
		    int count, amount;
	    
            	    if (tofq[0].equals("download")) 
	      	    {
		query = "select * FROM (select "+
"machine_name, SUM(doc_size) AS sum1 FROM proxy_log, ip_machine " +
"WHERE url_requested" + 
" LIKE '%"+keywords[0]+"%' AND log_tag NOT LIKE '%ERR%' AND time BETWEEN "+
from+" AND " + to +  " AND proxy_log.client_address = ip_machine.ip_address " +
"GROUP BY machine_name) ORDER BY sum1 DESC" ;
	      	    }
	    	    else 
	            {
		query = "select * FROM (select" +
" machine_name, COUNT(*) AS cnt FROM proxy_log, ip_machine WHERE " +
"url_requested LIKE"+ "'%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND log_tag NOT LIKE '%ERR%'" + 
" AND proxy_log.client_address = ip_machine.ip_address " + 
"GROUP BY machine_name) ORDER BY cnt DESC" ;
	      	    }
	    	      
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("machine_name");
			    if (tofq[0].equals("download")) {
			    	if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100%>");
				    out.println("<tr><td><center>Machines</center><td>No. of Bytes</tr>");
			    	}
			// in case of download, print the amount of download
			        amount = rs.getInt("sum1");
			        out.println("<tr><td>"+result + " <td> " +amount+"</tr>");
			    }
			    else {
			    	if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100%>");
				    out.println("<tr><td><center>Machines</center><td>No. of Requests</tr>");
			    	}
			// in case of requests, print the number of requests
			        count = rs.getInt("cnt");
			        out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      	 	}
	      		else {
	         	    if (i == 0) {
		     		out.println("no such machine exists");
		  	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	}
 
                //------------------------------------------------
		//process form 7 - traffic pattern
		//-----------------------------------------------
	  	else if (form_name[0].equals("trend")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String temp,query;
	    	    long max = 0, arr[];
    	    	    arr = new long[20];
    	    	    long from1, to1;
    	    	    long interval = (to - from)/20;
    	    	    for (int i=0; i<20; i++){
    	      		from1=from + i*interval;
	      		to1=from+(i+1)*interval;
	      		query = "select" +
" SUM(doc_size) AS sum1 FROM proxy_log WHERE time BETWEEN "+ from1+" AND "+to1;
	      
	      		rs = stmt.executeQuery(query);
	      		rs.next();
	      		arr[i] = rs.getInt("sum1");
	      		if (max < arr[i])
	      	  	    max=arr[i];
	    	    }
	    	    if (max != 0) {
	        	out.print("The specified interval has been divided "+
			"into 20 divisions <BR><BR><BR>");
		        out.println("<font color=red>");
	    	    }
	    	    for (int i=1; i<=20; i++){
	      	    	if (max == 0) {
	          	    out.println("no traffic in this period");
	            	    break;
	      	    	}
	      	    	arr[i-1]=(int) (arr[i-1]*60)/max;
	      	    	if (i < 10) {
	          	    out.print("&nbsp;&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	else  {
	          	    out.print("&nbsp;"+i+"&nbsp;|");
		    	}
	      	    	for (int j=1; j<=arr[i-1]; j++){
		  	    out.print("#");
	            	}
	      	    	out.println("<BR>");
	    	    } 
	    	    out.close();
	  	}
	          //---------------------------------------------------
	  	  // processing form 8 - root query on any user's habits
		  //---------------------------------------------------
		  
	  	else if (form_name[0].equals("user_info_for_root")) {
            	    String user_name[] = req.getParameterValues("user_name");
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String st[] = req.getParameterValues("st");
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String domain = "";
	    // we neglect the choice of domain if he wants to search for domains
	    	    if (tofq[0].equals("url")) 
	      		domain = st[0];
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
	    	    String query =
		 "SELECT * FROM (SELECT url_requested, COUNT (*) AS cnt FROM "+
  "proxy_log WHERE url_requested LIKE '%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+ to+" AND url_requested LIKE '%" +domain+"%' AND log_tag NOT " +
"LIKE '%ERR%' AND user_name = '"+user_name[0]+ "' GROUP BY "+ "url_requested)"+ 
" ORDER BY cnt DESC";
 
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("url_requested");
			    count = rs.getInt("cnt");
			    if (tofq[0].equals("url")) {
			    	if (i == 0) {
				    out.println("<center><table border=1 cellpadding = 5 width=100%>");
				    out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			        }
			        out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    }
			    else {
			    	if (i == 0) {
				     out.println("<center><table border=1 cellpadding = 5 width=100%>");
				     out.println("<tr><td><center>Domain</center><td>No. of Hits</tr>");
			      	}
		  		int index = result.indexOf("/");
		  		if (index == -1) {
			            out.println("<tr><td>"+result + " <td> " +count+"</tr>");
		  		}
		  	    	else {
		    		    int index1 = result.indexOf(keywords[0]);
		    		    if ((index1 != -1) &&  (index1 <= index))
			    		out.println("<tr><td>"+result.substring(0,index) + " <td> " +count+"</tr>");
		  		}
			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      		} else {
			    if (i == 0) {
			    	out.println("No sites found");
		  	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      	    	}
	    	    }
	    	    out.close();
	  	}
	  //--------------------------------------------------
	  // sites visited from a machine
	  //-------------------------------------------------
	  	else if (form_name[0].equals("machine_info")) {
            	    String machine_name[] = req.getParameterValues("machine_name");
		    String ip_no = IPAddress.ipAddress (machine_name[0]);
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String st[] = req.getParameterValues("st");
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String domain = "";
	    // we neglect the choice of domain if he wants to search for domains
	    	    if (tofq[0].equals("url")) 
	      		domain = st[0];
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp;
		    int count;
	    	    String query =
		 "SELECT * FROM (SELECT url_requested, COUNT (*) AS cnt FROM "+
  "proxy_log WHERE url_requested LIKE '%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+ to+" AND url_requested LIKE '%" +domain+"%' AND log_tag NOT " +
"LIKE '%ERR%' AND client_address = '"+ip_no+ "' GROUP BY "+ 
"url_requested)"+ " ORDER BY cnt DESC";
 
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			    result = rs.getString("url_requested");
			    count = rs.getInt("cnt");
			    if (tofq[0].equals("url")) {
			    	if (i == 0) {
				     out.println("<center><table border=1 cellpadding = 5 width=100%>");
				     out.println("<tr><td><center>URL</center><td>No. of Hits</tr>");
			      	}
			        out.println("<tr><td>"+result + " <td> " +count+"</tr>");
			    }
			    else {
			    	if (i == 0) {
				     out.println("<center><table border=1 cellpadding = 5 width=100%>");
				     out.println("<tr><td><center>Domain</center><td>No. of Hits</tr>");
			      	}
		  		int index = result.indexOf("/");
		  		if (index == -1) {
			            out.println("<tr><td>"+result + " <td> " +count+"</tr>");
		  		}
		  	    	else {
		    		    int index1 = result.indexOf(keywords[0]);
		    		    if ((index1 != -1) &&  (index1 <= index))
			                out.println("<tr><td>"+result.substring(0,index) + " <td> " +count+"</tr>");
		  		}
			    }
			    if (i == (topno - 1)) {
			    	out.println("</table></center></body></html>");
			    } 
	      		} else {
			    if (i == 0) {
			    	out.println("No sites found");
		  	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      	    	}
	    	    }
	    	    out.close();
	  	}
            //-------------------------------------------------
	    //error statistics
	    //------------------------------------------------
	  	else if (form_name[0].equals("error")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");

	    	    int topno = Integer.parseInt(top[0]);
	    	    String result, temp,query;
		    int count;
	    
	    query = "SELECT * FROM (SELECT" +
" url_requested, COUNT(*) as cnt FROM proxy_log WHERE url_requested LIKE "+ 
"'%"+keywords[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND log_tag LIKE '%" + tofq[0] +" %' GROUP BY " +
" url_requested) ORDER BY cnt DESC" ;
	    	      
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			   if (i == 0) {
			       out.println("<center><table border=1 cellpadding = 5 width=100%>");
			       out.println("<tr><td><center>URL</center><td>No. of Errors</tr>");
			    }
			    count = rs.getInt("cnt");
			    result = rs.getString("url_requested");
			    out.println("<tr><td>" + result + " <td> " +count+"</tr>");
			    if (i == (topno - 1)){
			    	out.println("</table></center></body></html>");
			    }
	      	   	}
	      		else {
			    if (i == 0) {
			    	out.println("No sites found");
		  	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	} 
                 //----------------------------------------------------
		 // statistics on cache hit / miss
		 //----------------------------------------------------
	  	else if (form_name[0].equals("cache")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
	    	    }
 		    long to = processDate (req,"2");
	            try {
	      	    	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred");
			out.close();
	    	    }
	    	    String keywords[] = req.getParameterValues("keywords");
	    	    String st[] = req.getParameterValues("st");
	    
	    	    int topno = Integer.parseInt(top[0]);
	    	    String result,temp,query;
		    String hitormiss = "HIT";
		    int count;

		    if (tofq[0].equals("miss")) 
		    	hitormiss = "MISS";
			
	    query = "SELECT * FROM (SELECT" +
" url_requested, COUNT(*) as cnt FROM proxy_log WHERE url_requested LIKE "+ 
"'%"+keywords[0]+"%' AND url_requested like '%"+st[0]+"%' AND time BETWEEN "+
from+" AND "+to+" AND log_tag LIKE '%" + hitormiss +" %' GROUP BY " +
" url_requested) ORDER BY cnt DESC" ;
		    
	    	    rs = stmt.executeQuery(query);
	    	    for (int i = 0; i < topno; i++) {
	      		if (rs.next()) {
			   if (i == 0) {
			       out.println("<center><table border=1 cellpadding = 5 width=100%>");
			       out.println("<tr><td><center>URL</center><td>No. of Hits/Misss</tr>");
			    }
			    count = rs.getInt("cnt");
			    result = rs.getString("url_requested");
			    out.println("<tr><td>" + result + " <td> " +count+"</tr>");
			    if (i == (topno - 1)){
			    	out.println("</table></center></body></html>");
	      	   	    }
	      	   	}
	      		else {
			    if (i == 0) {
			    	out.println("No sites found");
		  	    } else {
			    	out.println("</table></center></body></html>");
			    }
			    break;
	      		}
	    	    }
	    	    out.close();
	  	} 
                //----------------------------------------------
		// a form to allow root to delete tuples in specified interval
		//-------------------------------------------------------
		else if (form_name[0].equals("delete")) {
	    	    long from = processDate (req,"1");
	    	    try {
	            	if (from == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
		    }
	    	    long to = processDate (req,"2");
	    	    try {
	            	if (to == -1)  // check for validity of date1
			    throw new MyException();
	    	    }
	    	    catch (MyException e) {
	      		out.println("you erred ");
			out.close();
		    }
		    
		    String query = "DELETE FROM proxy_log WHERE " +
	" time BETWEEN " + from + " AND " + to;
		    stmt.executeQuery (query);
		    out.println("deletion done successfully");
		}

	    }
    	}
  	catch (MyException e) {
    	    out.println("you erred3 ");
    	    out.println(e);
  	}
	catch (Exception e) {
	    out.println("you erred4 ");
	    out.println(e);
	}
	finally {
	    out.close();
	}
     }
  
/*
    note that s could be 1 or 2 depending upon the date being processed 
    it uses the class date verifier
*/

    public long processDate (HttpServletRequest req, String s)
    throws MyException
    {
	DateVerify dv = new DateVerify();
	String date []= req.getParameterValues("d"+s);
	String month[] = req.getParameterValues("m"+s);
	String year[] = req.getParameterValues("y"+s);
	String hour[] = req.getParameterValues("h"+s);
	String min[] = req.getParameterValues("mn"+s);
	
	try {
	    String submit[] = {date[0],month[0],year[0],hour[0],min[0]};
	    return dv.dateVerifier(submit)/1000;
	}
	catch (ArrayIndexOutOfBoundsException e) {
	    throw new MyException();
	}
    }

/* 
   the method takes a file name as an argument and prints that file on the
   user's page. Only the name of the file is passed. The path of the file is
   assumed to be /users/ug96/ashish/public_html/ at present.
*/
    public void printHeader (PrintWriter out, String filename) {
        final String path = "/users/ug96/ashish/proxy_log/forms/";
        try {
	    FileInputStream infile = new FileInputStream (path+filename);
	    InputStreamReader reader = new InputStreamReader (infile);
	    BufferedReader input = new BufferedReader (reader);

	    String temp;
	    temp = input.readLine();
	    while (temp != null)   // read till the end of file
	    {
	        out.println(temp);
		temp = input.readLine();
	    }
	    infile.close();
	    reader.close();
	    input.close();
	}
	catch (Exception e) {
   	    out.println (e+" in pageprint");  // error checking message 
	}
    }

    public void printPage (PrintWriter out, String filename) {
        final String path = "/users/ug96/ashish/proxy_log/forms/";
        try {
	    FileInputStream infile = new FileInputStream (path+filename);
	    InputStreamReader reader = new InputStreamReader (infile);
	    BufferedReader input = new BufferedReader (reader);

	    String temp;
	    temp = input.readLine();
	    while (temp != null)   // read till the end of file
	    {
	        out.println(temp);
		temp = input.readLine();
	    }
	    infile.close();
	    reader.close();
	    input.close();
	    out.close();
	}
	catch (Exception e) {
   	    out.println (e+" in pageprint");  // error checking message 
	}
    }
}
